//#include "wrapper.h"

#include "../filters/binarize/filter.h"
#include "../filters/invert/filter.h"
#include "../filters/logic/filter.h"
#include "../filters/merge/filter.h"
#include "../filters/convolution/filter.h"
#include "../filters/lut/lut/filter.h"
#include "../filters/lut/luts/filter.h"
#include "../filters/lut/lutf/filter.h"
#include "../filters/lut/lutxy/filter.h"
#include "../filters/lut/lutxyz/filter.h"
#include "../filters/lut/lutsx/filter.h"
#include "../filters/mask/edge/filter.h"
#include "../filters/mask/motion/filter.h"
#include "../filters/mask/hysteresis/filter.h"
#include "../filters/morphologic/expand/filter.h"
#include "../filters/morphologic/inpand/filter.h"
#include "../filters/morphologic/inflate/filter.h"
#include "../filters/morphologic/deflate/filter.h"
#include "../filters/blur/mapped/filter.h"
//
#include "../filters/support/adddiff/filter.h"
#include "../filters/support/makediff/filter.h"
#include "../filters/support/average/filter.h"
#include "../filters/support/clamp/filter.h"

#include "../../avs25/avs25.h"
#include "../helpers/avs25/helpers_avs25.h"

//#include "../common/functions/functions.h"

using namespace Filtering;
//using namespace MaskTools::Avs25;
using namespace Filtering::MaskTools::Filters;
//using namespace MaskTools::Functions;

extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env)
{
   Avisynth25::Filter<Invert::Filter>::create( env );

   Avisynth25::Filter<Binarize::Filter>::create( env );

   Avisynth25::Filter<Morphologic::Inflate::Filter>::create( env );
   Avisynth25::Filter<Morphologic::Deflate::Filter>::create( env );
   Avisynth25::Filter<Morphologic::Inpand::Filter>::create( env );
   Avisynth25::Filter<Morphologic::Expand::Filter>::create( env );

   Avisynth25::Filter<Lut::Single::Filter>::create( env );
   Avisynth25::Filter<Lut::Dual::Filter>::create( env );
   Avisynth25::Filter<Lut::Trial::Filter>::create( env );
   Avisynth25::Filter<Lut::Spatial::Filter>::create( env );
   Avisynth25::Filter<Lut::Frame::Filter>::create( env );
   Avisynth25::Filter<Lut::SpatialExtended::Filter>::create( env );

   Avisynth25::Filter<Merge::Filter>::create( env );

   Avisynth25::Filter<Logic::Filter>::create( env );

   Avisynth25::Filter<Convolution::Filter>::create( env );

   Avisynth25::Filter<Blur::Mapped::Filter>::create( env );

   Avisynth25::Filter<Support::MakeDiff::Filter>::create( env );
   Avisynth25::Filter<Support::Average::Filter>::create( env );
   Avisynth25::Filter<Support::AddDiff::Filter>::create( env );
   Avisynth25::Filter<Support::Clamp::Filter>::create( env );

   Avisynth25::Filter<Mask::Motion::Filter>::create( env );
   Avisynth25::Filter<Mask::Edge::Filter>::create( env );
   Avisynth25::Filter<Mask::Hysteresis::Filter>::create( env );

   MaskTools::Avs25::Helpers::DeclareHelpers(env);

   return("MaskTools: a set of tools to work with masks");
}
