%INCLUDE "common.asm"

SECTION .rodata

;=============================================================================
; Code
;=============================================================================

SECTION .text

   mt_mangle Binarize, lower8_mmx
   mt_mangle Binarize, upper8_mmx
   mt_mangle Binarize, lower8_isse
   mt_mangle Binarize, upper8_isse
   mt_mangle Binarize, lower8_3dnow
   mt_mangle Binarize, upper8_3dnow
   
%MACRO MT_LOWER_ROLLED  0
   movq                 mm0, mm7
   psubusb              mm0, [edi + eax]
   pcmpeqb              mm0, mm6
   movq                 [edi + eax], mm0
%ENDMACRO

%MACRO MT_UPPER_ROLLED  0
   movq                 mm0, [edi + eax]
   psubusb              mm0, mm7
   pcmpeqb              mm0, mm6
   movq                 [edi + eax], mm0
%ENDMACRO

%MACRO MT_ZEROED_ROLLED 0
   movq                 [edi + eax], mm6
%ENDMACRO

%MACRO MT_LOWER_UNROLLED 1
   %1                   edi + eax + 320

   movq                 mm0, mm7
   movq                 mm1, mm7
   movq                 mm2, mm7
   movq                 mm3, mm7
   psubusb              mm0, [edi + eax]
   psubusb              mm1, [edi + eax + 8]
   psubusb              mm2, [edi + eax + 16]
   psubusb              mm3, [edi + eax + 24]
   pcmpeqb              mm0, mm6
   pcmpeqb              mm1, mm6
   pcmpeqb              mm2, mm6
   pcmpeqb              mm3, mm6
   movq                 [edi + eax], mm0
   movq                 [edi + eax + 8], mm1
   movq                 [edi + eax + 16], mm2
   movq                 [edi + eax + 24], mm3
   
   movq                 mm0, mm7
   movq                 mm1, mm7
   movq                 mm2, mm7
   movq                 mm3, mm7
   psubusb              mm0, [edi + eax + 32]
   psubusb              mm1, [edi + eax + 40]
   psubusb              mm2, [edi + eax + 48]
   psubusb              mm3, [edi + eax + 56]
   pcmpeqb              mm0, mm6
   pcmpeqb              mm1, mm6
   pcmpeqb              mm2, mm6
   pcmpeqb              mm3, mm6
   movq                 [edi + eax + 32], mm0
   movq                 [edi + eax + 40], mm1
   movq                 [edi + eax + 48], mm2
   movq                 [edi + eax + 56], mm3
%ENDMACRO

%MACRO MT_UPPER_UNROLLED 1
   %1                   edi + eax + 320

   movq                 mm0, [edi + eax]
   movq                 mm1, [edi + eax + 8]
   movq                 mm2, [edi + eax + 16]
   movq                 mm3, [edi + eax + 24]
   psubusb              mm0, mm7
   psubusb              mm1, mm7
   psubusb              mm2, mm7
   psubusb              mm3, mm7
   pcmpeqb              mm0, mm6
   pcmpeqb              mm1, mm6
   pcmpeqb              mm2, mm6
   pcmpeqb              mm3, mm6
   movq                 [edi + eax], mm0
   movq                 [edi + eax + 8], mm1
   movq                 [edi + eax + 16], mm2
   movq                 [edi + eax + 24], mm3
   
   movq                 mm0, [edi + eax + 32]
   movq                 mm1, [edi + eax + 40]
   movq                 mm2, [edi + eax + 48]
   movq                 mm3, [edi + eax + 56]
   psubusb              mm0, mm7
   psubusb              mm1, mm7
   psubusb              mm2, mm7
   psubusb              mm3, mm7
   pcmpeqb              mm0, mm6
   pcmpeqb              mm1, mm6
   pcmpeqb              mm2, mm6
   pcmpeqb              mm3, mm6
   movq                 [edi + eax + 32], mm0
   movq                 [edi + eax + 40], mm1
   movq                 [edi + eax + 48], mm2
   movq                 [edi + eax + 56], mm3
%ENDMACRO

%MACRO MT_ZEROED_UNROLLED 1
   %1                   edi + eax + 320

   movq                 [edi + eax], mm6
   movq                 [edi + eax + 8], mm6
   movq                 [edi + eax + 16], mm6
   movq                 [edi + eax + 24], mm6
   movq                 [edi + eax + 32], mm6
   movq                 [edi + eax + 40], mm6
   movq                 [edi + eax + 48], mm6
   movq                 [edi + eax + 56], mm6
%ENDMACRO

%MACRO MT_BINARIZE_ENDLINE 0
   add                  edi, [esp + .nDstPitch]
%ENDMACRO

%MACRO MT_BINARIZE_TRICK_LOWER 0
   inc                  eax
%ENDMACRO

%MACRO MT_BINARIZE_TRICK_UPPER 0
%ENDMACRO

%MACRO MT_BINARIZE_COMMON 2
   MT_SET_STACK         0, edi, ebp
   .pDst                PARAM(1)
   .nDstPitch           PARAM(2)
   .nThreshold          PARAM(3)
   .nWidth              PARAM(4)
   .nHeight             PARAM(5)
   
   mov                  eax, [esp + .nThreshold]
   MT_BINARIZE_TRICK_ %+ %1
   movd                 mm7, eax
   punpcklbw            mm7, mm7
   punpcklwd            mm7, mm7
   pxor                 mm6, mm6
   punpckldq            mm7, mm7
   
   mov                  edi, [esp + .pDst]

   mov                  ebp, [esp + .nDstPitch]
   sub                  ebp, [esp + .nWidth]
   
   cmp                  eax, 256
   je                   .zeroed

   MT_UNROLL_INPLACE_WIDTH    {MT_ %+ %1 %+ _UNROLLED %2}, MT_ %+ %1 %+ _ROLLED, MT_BINARIZE_ENDLINE
   
   jmp                  .end
   
.zeroed
  
   MT_UNROLL_INPLACE_WIDTH    {MT_ZEROED_UNROLLED %2}, MT_ZEROED_ROLLED, MT_BINARIZE_ENDLINE
   
.end   
      
   MT_REL_STACK
%ENDMACRO

lower8_mmx :
   MT_BINARIZE_COMMON   LOWER, MT_NOPREFETCH
   
upper8_mmx :
   MT_BINARIZE_COMMON   UPPER, MT_NOPREFETCH
   
lower8_3dnow :
   MT_BINARIZE_COMMON   LOWER, MT_PREFETCHW
   
upper8_3dnow :
   MT_BINARIZE_COMMON   UPPER, MT_PREFETCHW

lower8_isse :
   MT_BINARIZE_COMMON   LOWER, MT_PREFETCHT0
   
upper8_isse :
   MT_BINARIZE_COMMON   UPPER, MT_PREFETCHT0




