%INCLUDE "common.asm"

SECTION .rodata
ALIGN 16
   MT_BYTE_FF     : TIMES 16 DB 0xFF


;=============================================================================
; Code
;=============================================================================

SECTION .text

   mt_mangle Invert, invert8_mmx
   mt_mangle Invert, invert8_isse
   mt_mangle Invert, invert8_3dnow
   
%MACRO MT_INVERT_ROLLED 0
   movq                 mm0, [edi + eax]
   pxor                 mm0, mm7
   movq                 [edi + eax], mm0
%ENDMACRO

%MACRO MT_INVERT_UNROLLED 1
   %1                   edi + eax + 320

   movq                 mm0, [edi + eax]
   movq                 mm1, [edi + eax + 8]
   movq                 mm2, [edi + eax + 16]
   movq                 mm3, [edi + eax + 24]
   pxor                 mm0, mm7
   pxor                 mm1, mm7
   pxor                 mm2, mm7
   pxor                 mm3, mm7
   movq                 [edi + eax], mm0
   movq                 [edi + eax + 8], mm1
   movq                 [edi + eax + 16], mm2
   movq                 [edi + eax + 24], mm3
   
   movq                 mm0, [edi + eax + 32]
   movq                 mm1, [edi + eax + 40]
   movq                 mm2, [edi + eax + 48]
   movq                 mm3, [edi + eax + 56]
   pxor                 mm0, mm7
   pxor                 mm1, mm7
   pxor                 mm2, mm7
   pxor                 mm3, mm7
   movq                 [edi + eax + 32], mm0
   movq                 [edi + eax + 40], mm1
   movq                 [edi + eax + 48], mm2
   movq                 [edi + eax + 56], mm3
%ENDMACRO

%MACRO MT_INVERT_ENDLINE 0
   add                  edi, [esp + .nDstPitch]
%ENDMACRO

%MACRO MT_INVERT_COMMON 1
   MT_SET_STACK         0, edi
   .pDst                PARAM(1)
   .nDstPitch           PARAM(2)
   .nWidth              PARAM(3)
   .nHeight             PARAM(4)
   
   movq                 mm7, [MT_BYTE_FF]  
   
   mov                  edi, [esp + .pDst]
   
   MT_UNROLL_INPLACE_WIDTH    {MT_INVERT_UNROLLED %1}, MT_INVERT_ROLLED, MT_INVERT_ENDLINE
      
   MT_REL_STACK
%ENDMACRO

invert8_mmx:
   MT_INVERT_COMMON     MT_NOPREFETCH
   
invert8_isse:
   MT_INVERT_COMMON     MT_PREFETCHT0
   
invert8_3dnow:
   MT_INVERT_COMMON     MT_PREFETCHW  
